From: Masami Hiramatsu <mhiramat@kernel.org>
To: Steven Rostedt <rostedt@goodmis.org>, linux-kernel@vger.kernel.org
Cc: mhiramat@kernel.org, Ingo Molnar <mingo@redhat.com>,
Namhyung Kim <namhyung@kernel.org>,
Tom Zanussi <tom.zanussi@linux.intel.com>,
Arnaldo Carvalho de Melo <acme@kernel.org>,
linux-trace-users@vger.kernel.org,
linux-kselftest@vger.kernel.org, shuah@kernel.org
Subject: [PATCH v2 17/17] selftests: ftrace: Add a testcase for array type with kprobe_event
Date: Thu, 22 Feb 2018 00:02:27 +0900 [thread overview]
Message-ID: <151922534694.6217.17932827779274127190.stgit@devbox> (raw)
In-Reply-To: <151922484560.6217.1143686155616343906.stgit@devbox>
Add a testcase for array type with kprobe event.
This tests good/bad syntax combinations and also
the traced data is correct in several way.
If the kernel doesn't support array type, it skips
the test as UNSUPPORTED.
Signed-off-by: Masami Hiramatsu <mhiramat@kernel.org>
---
.../ftrace/test.d/kprobe/kprobe_args_array.tc | 75 ++++++++++++++++++++
1 file changed, 75 insertions(+)
create mode 100644 tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc
diff --git a/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc
new file mode 100644
index 000000000000..27c9628c1fff
--- /dev/null
+++ b/tools/testing/selftests/ftrace/test.d/kprobe/kprobe_args_array.tc
@@ -0,0 +1,75 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+# description: Kprobe event array argument
+
+[ -f kprobe_events ] || exit_unsupported # this is configurable
+
+grep -q "<type>\[<array-size>\]" README || exit_unsupported # version issue
+
+GOODSYM="_sdata"
+if ! grep -qw ${GOODSYM} /proc/kallsyms ; then
+ GOODSYM="create_trace_kprobe"
+fi
+case `uname -m` in
+x86_64)
+ ARG2=%si
+ OFFS=8
+;;
+i[3456]86)
+ ARG2=%cx
+ OFFS=4
+;;
+aarch64)
+ ARG2=%x1
+ OFFS=8
+;;
+arm*)
+ ARG2=%r1
+ OFFS=4
+;;
+*)
+ echo "Please implement other architecture here"
+ exit_untested
+esac
+
+create_testprobe() { # args
+ echo "p:testprobe create_trace_kprobe $*" > kprobe_events
+}
+
+echo 0 > events/enable
+echo > kprobe_events
+
+: "Syntax test"
+create_testprobe "+0(${ARG2}):x8[1] +0(${ARG2}):s16[1] +0(${ARG2}):u32[1]"
+create_testprobe "+0(${ARG2}):x64[1] +0(${ARG2}):symbol[1]"
+create_testprobe "+0(${ARG2}):b2@3/8[1] +0(${ARG2}):string[1]"
+create_testprobe "+0(${ARG2}):x8[64] @${GOODSYM}:x8[4]"
+
+! create_testprobe "${ARG2}:x8[1]" # Can not use array type on register
+! create_testprobe "\$comm:x8[1]" # Can not use array type on \$comm
+! create_testprobe "\$comm:string[1]" # No, even if it is string array
+! create_testprobe "+0(${ARG2}):x64[0]" # array size >= 1
+! create_testprobe "+0(${ARG2}):x64[65]" # array size <= 64
+
+: "Test get argument (1)"
+create_testprobe "arg1=+0(${ARG2}):string[1]" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo test >> kprobe_events
+tail -n 1 trace | grep -qe "testprobe.* arg1={\"test\"}"
+echo 0 > events/kprobes/testprobe/enable
+
+: "Test get argument (2)"
+create_testprobe "arg1=+0(${ARG2}):string[3]" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo foo bar buzz >> kprobe_events
+tail -n 1 trace | grep -qe "testprobe.* arg1={\"foo\",\"bar\",\"buzz\"}"
+echo 0 > events/kprobes/testprobe/enable
+
+: "Test get argument (3)"
+create_testprobe "arg1=+0(+0(${ARG2})):u8[4]" > kprobe_events
+echo 1 > events/kprobes/testprobe/enable
+! echo 1234 >> kprobe_events
+tail -n 1 trace | grep -qe "testprobe.* arg1={49,50,51,52}" # ascii code
+echo 0 > events/kprobes/testprobe/enable
+
+echo > kprobe_events
prev parent reply other threads:[~2018-02-21 15:02 UTC|newest]
Thread overview: 28+ messages / expand[flat|nested] mbox.gz Atom feed top
2018-02-21 14:54 [PATCH v2 00/17] tracing: probeevent: Improve fetcharg features Masami Hiramatsu
2018-02-21 14:54 ` [PATCH v2 01/17] tracing: probeevent: Fix to support minus offset from symbol Masami Hiramatsu
2018-02-21 23:41 ` Masami Hiramatsu
2018-02-22 1:53 ` Steven Rostedt
2018-02-22 6:35 ` Masami Hiramatsu
2018-02-22 7:45 ` [BUGFIX PATCH v2.1] " Masami Hiramatsu
2018-02-23 0:15 ` Namhyung Kim
2018-02-23 9:44 ` Masami Hiramatsu
2018-02-21 14:55 ` [PATCH v2 02/17] selftests: ftrace: Add probe event argument syntax testcase Masami Hiramatsu
2018-02-21 14:55 ` [PATCH v2 03/17] selftests: ftrace: Add a testcase for string type with kprobe_event Masami Hiramatsu
2018-02-21 14:56 ` [PATCH v2 04/17] tracing: probeevent: Cleanup print argument functions Masami Hiramatsu
2018-02-21 14:56 ` [PATCH v2 05/17] tracing: probeevent: Cleanup argument field definition Masami Hiramatsu
2018-02-21 14:57 ` [PATCH v2 06/17] tracing: probeevent: Remove NOKPROBE_SYMBOL from print functions Masami Hiramatsu
2018-02-21 14:57 ` [PATCH v2 07/17] tracing: probeevent: Introduce new argument fetching code Masami Hiramatsu
2018-02-23 4:30 ` Namhyung Kim
2018-02-23 9:43 ` Masami Hiramatsu
2018-02-21 14:58 ` [PATCH v2 08/17] tracing: probeevent: Return consumed bytes of dynamic area Masami Hiramatsu
2018-02-21 14:58 ` [PATCH v2 09/17] tracing: probeevent: Append traceprobe_ for exported function Masami Hiramatsu
2018-02-21 14:59 ` [PATCH v2 10/17] tracing: probeevent: Unify fetch_insn processing common part Masami Hiramatsu
2018-02-21 14:59 ` [PATCH v2 11/17] tracing: probeevent: Add symbol type Masami Hiramatsu
2018-02-21 15:00 ` [PATCH v2 12/17] x86: ptrace: Add function argument access API Masami Hiramatsu
2018-02-21 15:00 ` [PATCH v2 13/17] tracing: probeevent: Add $argN for accessing function args Masami Hiramatsu
2018-02-22 8:35 ` Masami Hiramatsu
2018-02-21 15:01 ` [PATCH v2 14/17] tracing: probeevent: Add array type support Masami Hiramatsu
2018-02-21 15:01 ` [PATCH v2 15/17] selftests: ftrace: Add a testcase for symbol type Masami Hiramatsu
2018-02-22 11:43 ` Masami Hiramatsu
2018-02-21 15:01 ` [PATCH v2 16/17] selftests: ftrace: Add a testcase for $argN with kprobe_event Masami Hiramatsu
2018-02-21 15:02 ` Masami Hiramatsu [this message]
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=151922534694.6217.17932827779274127190.stgit@devbox \
--to=mhiramat@kernel.org \
--cc=acme@kernel.org \
--cc=linux-kernel@vger.kernel.org \
--cc=linux-kselftest@vger.kernel.org \
--cc=linux-trace-users@vger.kernel.org \
--cc=mingo@redhat.com \
--cc=namhyung@kernel.org \
--cc=rostedt@goodmis.org \
--cc=shuah@kernel.org \
--cc=tom.zanussi@linux.intel.com \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox
Powered by JetHome